import { PropertyWrapperClass } from '../../property-wrapper';
export class ComponentLoaderCommonAClass {
    constructor(componentFactoryResolver) {
        this.componentFactoryResolver = componentFactoryResolver;
        this.__prefix = '_';
        this.__suffix = '';
        this.__componentPropertyName = '__componentRef';
        this.__properties = [];
    }
    set __component(value) {
        if (this.__componentPropertyName) {
            this[this.__componentPropertyName] = value;
        }
    }
    get __component() {
        return this[this.__componentPropertyName];
    }
    __assign(p = this.__properties, source) {
        if (this.__component) {
            if (p instanceof Array) {
                p.forEach((property) => {
                    this.__set(property, source[property]);
                });
            }
            else if (p) {
                this.__set(p, source[p]);
            }
        }
    }
    __set(property, value) {
        if (this.__component && this.__component.hasOwnProperty('instance')) {
            Object.assign(this.__component.instance, {
                [property]: value
            });
        }
    }
    __get(property) {
        if (property.length > 0) {
            if (this.__component && this.__component.hasOwnProperty('instance')) {
                return this.__component.instance[property];
            }
        }
        else {
            throw new Error(`ComponentLoaderCommonAClass.__get(property ${property}) : property length is 0`);
        }
    }
    __subscribe(property, ...args) {
        if (this.__component && this.__component.instance.hasOwnProperty(property)) {
            this.__get(property).subscribe(...args);
        }
        else {
            throw new Error(`this.component.instance does not have property ${property}`);
        }
    }
    __resolve(component) {
        if (component) {
            return this.componentFactoryResolver.resolveComponentFactory(component);
        }
    }
    __wrap(p = this.__properties, source, setter, getter) {
        this.wrapper = (this.wrapper) ? this.wrapper : new PropertyWrapperClass(this.__prefix, this.__suffix);
        if (this.wrapper instanceof PropertyWrapperClass) {
            this.wrapper.wrap(source, p, setter, getter);
            p.forEach((property) => {
                if (this.wrapper) {
                    this.__set(property, source[this.wrapper.propertyName(property)]);
                }
            });
        }
        return this;
    }
}
//# sourceMappingURL=component-loader-common.aclass.js.map