import { PropertyWrapperClass } from '../../property-wrapper';
export function ComponentLoader(config) {
    return function (source) {
        const wrapper = new PropertyWrapperClass(config.prefix, config.suffix);
        Object.defineProperties(source.prototype, {
            __assign: {
                value: function __assign(p) {
                    this.componentLoaderService.__assign(p, this);
                }
            },
            __component: {
                set: function __component(value) {
                    this.componentLoaderService.__component = value;
                },
                get: function __component() {
                    return this.componentLoaderService.__component;
                }
            },
            __componentPropertyName: {
                set: function __componentPropertyName(value) {
                    this.componentLoaderService.componentPropertyName = value;
                },
                get: function __componentPropertyName() {
                    return this.componentLoaderService.componentPropertyName;
                }
            },
            __create: {
                value: function __create() {
                    this.componentLoaderService.init(config, this);
                    return this;
                }
            },
            __destroy: {
                value: function __destroy() {
                    this.componentLoaderService.__destroy();
                }
            },
            __get: {
                value: function __get(property) {
                    return this.componentLoaderService.__get(property);
                }
            },
            __prefix: {
                set: function __prefix(value) {
                    this.componentLoaderService.prefix = value;
                },
                get: function __prefix() {
                    return this.componentLoaderService.prefix;
                }
            },
            __properties: {
                set: function __properties(value) {
                    this.componentLoaderService.properties = value;
                },
                get: function __properties() {
                    return this.componentLoaderService.properties;
                }
            },
            __set: {
                value: function __set(property, value) {
                    this.componentLoaderService.__set(property, value);
                }
            },
            __suffix: {
                set: function __suffix(value) {
                    this.componentLoaderService.suffix = value;
                },
                get: function __suffix() {
                    return this.componentLoaderService.suffix;
                }
            },
            __subscribe: {
                value: function __subscribe(property, ...args) {
                    this.componentLoaderService.__subscribe(property, ...args);
                }
            }
        });
        if (config.properties) {
            wrapper.wrap(source, config.properties, (targetPropertyName, sourcePropertyName, s) => {
                if (s) {
                    if (s['__set'] instanceof Function) {
                        s['__set'](targetPropertyName, s[sourcePropertyName]);
                    }
                }
            }, (targetPropertyName, s) => {
                if (s) {
                    if (s['__get'] instanceof Function) {
                        return s['__get'](targetPropertyName);
                    }
                }
            });
        }
    };
}
//# sourceMappingURL=component-loader.decorator.js.map