import { ApplicationRef, ComponentFactoryResolver, ElementRef, Injector, Type } from '@angular/core';
import { ComponentLoaderCommonAClass } from './component-loader-common.aclass';
import { ComponentLoaderConfigInterface, ComponentLoaderServiceInterface } from '../interface';
export declare class ComponentLoaderService<T> extends ComponentLoaderCommonAClass<T> implements ComponentLoaderServiceInterface<T> {
    private appRef;
    private injector;
    componentFactoryResolver: ComponentFactoryResolver;
    elementRef: ElementRef;
    prefix: string;
    suffix: string;
    componentPropertyName: string;
    properties: string[];
    private attached;
    constructor(appRef: ApplicationRef, injector: Injector, componentFactoryResolver: ComponentFactoryResolver, elementRef: ElementRef);
    __link<S>(properties: string[] | undefined, source: S): this;
    __create<D = T>(component: Type<D>): this;
    __destroy(): undefined;
    init<S>(config: ComponentLoaderConfigInterface<T>, source?: S): this;
    appendChild(container: string): this;
    attachView(): this;
    detachView(): this;
}
