import { ApplicationRef, ComponentFactoryResolver, ElementRef, Injectable, Injector } from '@angular/core';
import { ComponentLoaderCommonAClass } from './component-loader-common.aclass';
export class ComponentLoaderService extends ComponentLoaderCommonAClass {
    constructor(appRef, injector, componentFactoryResolver, elementRef) {
        super(componentFactoryResolver);
        this.appRef = appRef;
        this.injector = injector;
        this.componentFactoryResolver = componentFactoryResolver;
        this.elementRef = elementRef;
        this.attached = false;
    }
    set prefix(value) {
        this.__prefix = value;
    }
    get prefix() {
        return this.__prefix;
    }
    set suffix(value) {
        this.__suffix = value;
    }
    get suffix() {
        return this.__suffix;
    }
    set componentPropertyName(value) {
        this.__componentPropertyName = value;
    }
    get componentPropertyName() {
        return this.__componentPropertyName;
    }
    set properties(properties) {
        this.__properties = properties;
    }
    get properties() {
        return this.__properties;
    }
    __link(properties = this.properties, source) {
        if (properties instanceof Array) {
            this.__wrap(properties, source, (property, sourcePropertyName, s) => {
                if (s && this.__set instanceof Function) {
                    this.__set(property, s[sourcePropertyName]);
                }
            }, (property, s) => {
                if (this.__get instanceof Function) {
                    return this.__get(property);
                }
            });
        }
        return this;
    }
    __create(component) {
        if (!this.__component) {
            this.__component = this.__resolve(component).create(this.injector);
        }
        return this;
    }
    __destroy() {
        this.detachView();
        if (this.__component) {
            this.__component.destroy();
            this.__component = undefined;
        }
        return this.__component;
    }
    init(config, source) {
        Object.assign(this, config);
        this
            .__create(config.component)
            .attachView()
            .appendChild(config.container);
        if (source && config.properties) {
            this.__link(config.properties, source);
        }
        return this;
    }
    appendChild(container) {
        if (container && this.__component) {
            this
                .elementRef
                .nativeElement
                .querySelector(container)
                .appendChild(this.__component.hostView.rootNodes[0]);
        }
        return this;
    }
    attachView() {
        if (this.attached === false && this.__component) {
            this.appRef.attachView(this.__component.hostView);
            this.attached = true;
        }
        return this;
    }
    detachView() {
        if (this.__component && this.attached === true) {
            this.appRef.detachView(this.__component.hostView);
            this.attached = false;
        }
        return this;
    }
}
ComponentLoaderService.decorators = [
    { type: Injectable },
];
ComponentLoaderService.ctorParameters = () => [
    { type: ApplicationRef, },
    { type: Injector, },
    { type: ComponentFactoryResolver, },
    { type: ElementRef, },
];
//# sourceMappingURL=component-loader.service.js.map