import { StoreOriginalClass } from '../../store';
import { PrefixSuffixClass } from '../../src/prefixsuffix.class';
export class PropertyWrapperClass extends PrefixSuffixClass {
    constructor(prefix, suffix) {
        super(prefix, suffix);
        this.store = new StoreOriginalClass();
        this.wrapped = [];
    }
    wrap(source, properties, setter, getter) {
        try {
            if (source) {
                if (properties instanceof Array) {
                    properties.forEach((property) => {
                        this.wrapProperty(source, property, setter, getter);
                    });
                }
                else {
                    this.wrapProperty(source, properties, setter, getter);
                }
            }
        }
        catch (e) {
            if (e instanceof TypeError) {
            }
            else if (e instanceof RangeError) {
            }
            else if (e instanceof EvalError) {
            }
            else {
            }
            console.warn(e.message);
        }
    }
    wrapProperty(source, property, setter, getter) {
        if (this.wrapped.includes(property) === false) {
            const t = this;
            const store = this.store.setterGetter(source, property);
            const sourcePropertyName = this.propertyName(property);
            if (sourcePropertyName) {
                Object.defineProperty((source instanceof Function) ? source.prototype : source, sourcePropertyName, { writable: true, value: (source[property]) ? source[property] : source[sourcePropertyName] });
                Object.defineProperties((source instanceof Function) ? source.prototype : source, {
                    [property]: {
                        get: function () {
                            if (store.getter[property]) {
                                return store.getter[property].apply(this, arguments);
                            }
                            if (getter instanceof Function) {
                                return getter(property, this) || this[sourcePropertyName];
                            }
                        },
                        set: function (value) {
                            this[sourcePropertyName] = value;
                            if (store.setter[property]) {
                                store.setter[property].apply(this, arguments);
                            }
                            if (setter instanceof Function) {
                                setter(property, sourcePropertyName, this);
                            }
                        }
                    }
                });
                this.wrapped.push(property);
            }
            else {
                throw new Error(`sourcePropertyName is not generated.`);
            }
        }
    }
}
//# sourceMappingURL=property-wrapper.class.js.map